// IsAdminATL.cpp : Tests if user is Administrator using ATL
// Copyright (c) April 2007, Mihai Nita
//

#include <wtypes.h>
#include <Lm.h>

#include "IsAdminATL.h"

#ifdef __DEV_STUDIO_NET__
// This works with VS .NET, much cleaner

#include <atlsecurity.h>

bool IsAdminATL( WCHAR const *szUserName )
{
	_ASSERT(szUserName);

	bool bAdmin = FALSE;
	LOCALGROUP_USERS_INFO_0* localGroups;
	DWORD entriesread, totalentries;
	NET_API_STATUS nts = NetUserGetLocalGroups( NULL, szUserName, 0, 0, (unsigned char**)&localGroups, MAX_PREFERRED_LENGTH, &entriesread, &totalentries);

	if( nts == NERR_Success ) {
		for( DWORD i = 0; i < entriesread; ++i ) {
			NonATLSid( localGroups[i].lgrui0_name );

			// You can find the list of all well-known SIDs in atlsecurity.h
			try {
				CSid	gsid( localGroups[i].lgrui0_name );
				if( gsid == Sids::Admins() ) {
					bAdmin = TRUE;
					break;
				}
			}
			catch( CAtlException e ) {
				// we just go ahead with the next group
			}
		}
		NetApiBufferFree(localGroups);
	}

	return bAdmin;
}
#endif // __DEV_STUDIO_NET__
