// IsAdminTest.cpp : Tests the two implementations of IsAdmin
// Copyright (c) April 2007, Mihai Nita
//

#include <stdio.h>
#include <tchar.h>

#include "IsAdminAPI.h"
#include "IsAdminATL.h"

#ifdef _countof
#define	DIM(a)	_countof(a)
#else
#define	DIM(a)	(sizeof(a)/sizeof(a[0]))
#endif

int _tmain( int argc, TCHAR* argv[] )
{
	if( argc < 2 ) {
		_tprintf( _T("Usage: %s <UserName> [<UserName> ...]\n"), argv[0] );
		return 1;
	}

#define MAX_USER_NAME_LENGTH 1024
	WCHAR szUserName[MAX_USER_NAME_LENGTH];

	for( int i = 1; i < argc; i++ ) {
#ifdef UNICODE
		wcsncpy( szUserName, argv[i], DIM(szUserName) );
#else
		MultiByteToWideChar( CP_ACP, MB_PRECOMPOSED | MB_ERR_INVALID_CHARS, argv[i], -1, szUserName, DIM(szUserName) );
#endif

		_tprintf( _T("=======================\n") );
		_tprintf( _T("IsAdminAPI( \"%s\" ) = %s\n"), argv[i], IsAdminAPI(szUserName) ? _T("True") : _T("False") );

#ifdef __DEV_STUDIO_NET__
		_tprintf( _T("ATL_IsAdmin( \"%s\" ) = %s\n"), argv[i], IsAdminATL(szUserName) ? _T("True") : _T("False") );
#endif // __DEV_STUDIO_NET__

	}

	return 0;
}
